//+------------------------------------------------------------------+
//|                                                    VKW Bands.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+

#property copyright "Alksnis Gatis"
#property link      "2xpoint@gmail.com"
//----
#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 clrDodgerBlue
#property indicator_color2 clrSaddleBrown
#property indicator_color3 clrDodgerBlue
#property indicator_color4 clrSandyBrown
#property indicator_color5 clrSandyBrown
#property  indicator_style1  STYLE_DOT
#property  indicator_style2  STYLE_DOT
#property  indicator_width3  2
#property  indicator_width4  2
#property  indicator_width5  2
//---- input parameters 
extern string TimeFrame = "Current time frame";
extern int       RangePeriod=25;
extern int       SmoothPeriod=3;
extern int       SmoothMode=MODE_SMA;
extern int       Per=5;
extern bool      ShowArrow0 = TRUE;
extern bool      ShowArrow1 = TRUE;
extern bool      ShowTLine = TRUE;
extern color     ArrowUpColor=clrDodgerBlue;
extern color     ArrowDownColor=clrSandyBrown;
//---- buffers 
double ExtMapBuffer0[],ExtMapBufferda[],ExtMapBufferdb[],slope[];
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];

bool fb=false, fs=false;
double a[],t[],fa,fd;
int b;
datetime drop=0;

string indicatorFileName;
int    timeFrame;

//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init(){
//---- indicators 
   IndicatorBuffers(8);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexDrawBegin(0,SmoothPeriod);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexDrawBegin(1,SmoothPeriod);
   SetIndexBuffer(2,ExtMapBuffer0);
   SetIndexBuffer(3,ExtMapBufferda);
   SetIndexBuffer(4,ExtMapBufferdb);
   SetIndexBuffer(5,ExtMapBuffer3);
   SetIndexBuffer(6,ExtMapBuffer4);
   SetIndexBuffer(7,slope);
   
   indicatorFileName = WindowExpertName();
   timeFrame         = stringToTimeFrame(TimeFrame);
//---- 
   return(0);
}
//+------------------------------------------------------------------+ 
//| Custom indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit(){
//---- 
   ObjectsDeleteAll();
//---- 
   return(0);
}
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start(){
   int counted_bars = IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;

   if (timeFrame!=Period())
   {
      int limit = MathMin(MathMax(Bars-counted_bars,2*timeFrame/Period()),Bars-1);
      if (slope[limit]==-1) CleanPoint(limit,ExtMapBufferda,ExtMapBufferdb);
      for (int i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            ExtMapBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"",RangePeriod,SmoothPeriod,SmoothMode,Per,ShowArrow0,ShowArrow1,ShowTLine,ArrowUpColor,ArrowDownColor,0,y);
            ExtMapBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"",RangePeriod,SmoothPeriod,SmoothMode,Per,ShowArrow0,ShowArrow1,ShowTLine,ArrowUpColor,ArrowDownColor,1,y);
            ExtMapBuffer0[i] = iCustom(NULL,timeFrame,indicatorFileName,"",RangePeriod,SmoothPeriod,SmoothMode,Per,ShowArrow0,ShowArrow1,ShowTLine,ArrowUpColor,ArrowDownColor,2,y);
            slope[i]         = iCustom(NULL,timeFrame,indicatorFileName,"",RangePeriod,SmoothPeriod,SmoothMode,Per,ShowArrow0,ShowArrow1,ShowTLine,ArrowUpColor,ArrowDownColor,7,y);
            ExtMapBufferda[i] = EMPTY_VALUE;
            ExtMapBufferdb[i] = EMPTY_VALUE;
            if (slope[i]==-1) PlotPoint(i,ExtMapBufferda,ExtMapBufferdb,ExtMapBuffer0);
      }
      return(0);
   }

//----
   if(drop==0)drop=TimeCurrent()+60;
   if(drop<=TimeCurrent()){
      bool qwe=false;
      for(i=0;i<=30;i++){
         if(ObjectFind("ui"+i)  >0)  {ObjectDelete("ui"+i);  } 
         if(ObjectFind("uw"+i)  >0)  {ObjectDelete("uw"+i);  } 
         if(ObjectFind("txtu"+i)>0)  {ObjectDelete("txtu"+i);} 
         if(ObjectFind("tu"+i)  >0)  {ObjectDelete("tu"+i);  } 
         if(ObjectFind("di"+i)  >0)  {ObjectDelete("di"+i);  } 
         if(ObjectFind("dw"+i)  >0)  {ObjectDelete("dw"+i);  } 
         if(ObjectFind("txtd"+i)>0)  {ObjectDelete("txtd"+i);} 
         if(ObjectFind("td"+i)  >0)  {ObjectDelete("td"+i);  }
      }
      drop=TimeCurrent()+60;
   }
   int limit1,cnt,n_max,n_min;
   if (counted_bars==0){
      limit=Bars-RangePeriod;
      limit1=limit-SmoothPeriod;
   }
   if (counted_bars>0){
      limit=Bars-counted_bars;
      limit1=limit;
   }
   limit--;
   limit1--;
   if (slope[limit]==-1) CleanPoint(limit,ExtMapBufferda,ExtMapBufferdb);
   for(cnt=limit; cnt>=0;cnt--){
      ExtMapBuffer0[cnt]  = iCustom(NULL,0,"METRO",1,cnt);
      ExtMapBufferda[cnt] = EMPTY_VALUE;
      ExtMapBufferdb[cnt] = EMPTY_VALUE;
      slope[cnt] = slope[cnt+1];
      if (ExtMapBuffer0[cnt]>ExtMapBuffer0[cnt+1]) slope[cnt] =  1;
      if (ExtMapBuffer0[cnt]<ExtMapBuffer0[cnt+1]) slope[cnt] = -1;
      if (slope[cnt]==-1) PlotPoint(cnt,ExtMapBufferda,ExtMapBufferdb,ExtMapBuffer0);
   }
   for(cnt=limit; cnt>=0;cnt--){
      n_max=ArrayMaximum(ExtMapBuffer0,RangePeriod,cnt);
      n_min=ArrayMinimum(ExtMapBuffer0,RangePeriod,cnt);
      ExtMapBuffer3[cnt]=ExtMapBuffer0[n_max];
      ExtMapBuffer4[cnt]=ExtMapBuffer0[n_min];
   }
   for(cnt=limit1; cnt>=0;cnt--){
      ExtMapBuffer1[cnt]=iMAOnArray(ExtMapBuffer3,0,SmoothPeriod,0,SmoothMode,cnt);
      ExtMapBuffer2[cnt]=iMAOnArray(ExtMapBuffer4,0,SmoothPeriod,0,SmoothMode,cnt);
   }
   i=Bars-RangePeriod;
   while(i>=0){
      if(ExtMapBuffer0[i]>=ExtMapBuffer1[i])fs=true;
      if(fs==true&&ExtMapBuffer0[i]+0.1<ExtMapBuffer1[i]){
         if(ShowArrow1)
           SetArrow(242,ArrowDownColor,"ui"+i,1,Time[i],ExtMapBuffer1[i]+5,2);
         if(ShowArrow0)
           SetArrow(242,ArrowDownColor,"uw"+i,0,Time[i],High[i]+15*Point ,2);
         fa=FindNearFractal(Symbol(),0,MODE_UPPER,i);
         //SetText(Symbol(), "txtu"+b, "BUYSTOP "+DoubleToStr(High[b],Digits), Yellow, Time[b]+3*3600, High[b], 8, 0, 1);
         if(ShowTLine)
           SetTLine(ArrowDownColor, "tu"+b, Time[b]-5*3600, High[b], Time[b]+15*3600, High[b], false, 0, 2, 0);
         fs=false;
      }
      if(ExtMapBuffer0[i]<=ExtMapBuffer2[i])fb=true;
      if(fb==true&&ExtMapBuffer0[i]-0.1>ExtMapBuffer2[i]){
         if(ShowArrow1)
           SetArrow(241,ArrowUpColor,"di"+i,1,Time[i],ExtMapBuffer0[i],2);
         if(ShowArrow0)
           SetArrow(241,ArrowUpColor,"dw"+i,0,Time[i],Low[i]-2*Point  ,2);
         fd=FindNearFractal(Symbol(),0,MODE_LOWER,i);
         //SetText(Symbol(), "txtd"+b, "SELLSTOP "+DoubleToStr(Low[b],Digits), Yellow, Time[b]+3*3600, Low[b], 8, 0, -1);
         if(ShowTLine)
           SetTLine(ArrowUpColor, "td"+b, Time[b]-5*3600, Low[b], Time[b]+15*3600, Low[b], false, 0, 2, 0);
         fb=false;
      }
      
      i--;
      WindowRedraw();
      
   }
//---- 
   return(0);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :    ,  OBJ_ARROW.                |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cd -                                                           |
//|    cl -                                                          |
//|    nm -                ("" -    )     |
//|    t1 -           (0  -  )                      |
//|    p1 -              (0  - Bid)                              |
//|    sz -                (0  -  )                     |
//|    w  -               (0  -  )                    |
//+----------------------------------------------------------------------------+
void SetArrow(int cd, color cl, string nm="", int w=0, datetime t1=0, double p1=0, int sz=0) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[0];
  if (p1<=0) p1=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_ARROW, w, 0,0);
  ObjectSet(nm, OBJPROP_TIME1    , t1);
  ObjectSet(nm, OBJPROP_PRICE1   , p1);
  ObjectSet(nm, OBJPROP_ARROWCODE, cd);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_WIDTH    , sz);
}/*
void SetText(string sy, string nm, string tx, color cl, datetime t1=0, double p1=0, int fs=9, int w=0, int pos=1){
   
   int d=MarketInfo(sy, MODE_DIGITS);
   
   if (nm=="") nm=DoubleToStr(Time[0], 0);
   if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_TEXT, w, 0,0);
   if (d==0) if (StringFind(sy, "JPY")<0) d=4; else d=2;
   if (pos!=1) pos=-1;
   
   p1=NormalizeDouble(p1, d);
   
   ObjectSetText(nm, tx, fs);
   ObjectSet(nm, OBJPROP_COLOR,    cl);
   ObjectSet(nm, OBJPROP_TIME1 ,   t1);
   if(pos==1  && sy=="EURUSD")ObjectSet(nm,OBJPROP_PRICE1,p1+0.0015);
   if(pos==-1 && sy=="EURUSD")ObjectSet(nm,OBJPROP_PRICE1,p1-0.0002);
   if(pos==1  && sy=="GBPUSD")ObjectSet(nm,OBJPROP_PRICE1,p1+0.0035);
   if(pos==-1 && sy=="GBPUSD")ObjectSet(nm,OBJPROP_PRICE1,p1-0.0002);
   if(pos==1  && sy=="USDCHF")ObjectSet(nm,OBJPROP_PRICE1,p1+0.0015);
   if(pos==-1 && sy=="USDCHF")ObjectSet(nm,OBJPROP_PRICE1,p1-0.0002);
   if(pos==1  && sy=="USDJPY")ObjectSet(nm,OBJPROP_PRICE1,p1+0.15);
   if(pos==-1 && sy=="USDJPY")ObjectSet(nm,OBJPROP_PRICE1,p1-0.02);
   if(pos==1  && sy=="EURJPY")ObjectSet(nm,OBJPROP_PRICE1,p1+0.30);
   if(pos==-1 && sy=="EURJPY")ObjectSet(nm,OBJPROP_PRICE1,p1-0.02);
   if(pos==1  && sy=="GBPJPY")ObjectSet(nm,OBJPROP_PRICE1,p1+0.45);
   if(pos==-1 && sy=="GBPJPY")ObjectSet(nm,OBJPROP_PRICE1,p1-0.02);
   ObjectSet(nm, OBJPROP_FONTSIZE, fs);
   ObjectSet(nm, OBJPROP_BACK, false);
}
*/
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :   ,  OBJ_LABEL.                   |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    nm -                                                 |
//|    tx -                                                               |
//|    cl -                                                           |
//|    xd -  X                                              |
//|    yd -  Y                                              |
//|    cr -           (0 -  ,                     |
//|                                     1 -  ,                    |
//|                                     2 -  ,                      |
//|                                     3 -   )                    |
//|    fs -                (9 -    )                    |
//|    w  -               (0 -  )                     |
//+----------------------------------------------------------------------------+
/*void SetLabel(string nm, string tx, color cl, int xd, int yd, int cr=0, int fs=9, int w=0){
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_LABEL, w, 0,0);
  ObjectSetText(nm, tx, fs);
  ObjectSet(nm, OBJPROP_COLOR    , cl);
  ObjectSet(nm, OBJPROP_XDISTANCE, xd);
  ObjectSet(nm, OBJPROP_YDISTANCE, yd);
  ObjectSet(nm, OBJPROP_CORNER   , cr);
  ObjectSet(nm, OBJPROP_FONTSIZE , fs);
}*/
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.10.2007                                                     |
//|   :   OBJ_TREND                      |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    cl -                                                           |
//|    nm -                (  ""  -    )  |
//|    t1 -           (  0   - Time[10]                       |
//|    p1 -              (  0   - Low[10])                       |
//|    t2 -           (  0   -  )                   |
//|    p2 -              (  0   - Bid)                           |
//|    ry -                         (False -  )                  |
//|    st -                  (  0   -  )                 |
//|    wd -                 (  1   -  )                  |
//|    w  -               (  0   -  )                 |
//+----------------------------------------------------------------------------+
void SetTLine(color cl, string nm="", datetime t1=0, double p1=0, 
              datetime t2=0, double p2=0, bool ry=False, int st=0, int wd=1, int w=0) {
  if (nm=="") nm=DoubleToStr(Time[0], 0);
  if (t1<=0) t1=Time[10];
  if (p1<=0) p1=Low[10];
  if (t2<=0) t2=Time[0];
  if (p2<=0) p2=Bid;
  if (ObjectFind(nm)<0) ObjectCreate(nm, OBJ_TREND, w, 0,0, 0,0);
  ObjectSet(nm, OBJPROP_TIME1 , t1);
  ObjectSet(nm, OBJPROP_PRICE1, p1);
  ObjectSet(nm, OBJPROP_TIME2 , t2);
  ObjectSet(nm, OBJPROP_PRICE2, p2);
  ObjectSet(nm, OBJPROP_COLOR , cl);
  ObjectSet(nm, OBJPROP_RAY   , ry);
  ObjectSet(nm, OBJPROP_STYLE , st);
  ObjectSet(nm, OBJPROP_WIDTH , wd);
}
//+----------------------------------------------------------------------------+
//|     :   . aka KimIV,  http://www.kimiv.ru                    |
//+----------------------------------------------------------------------------+
//|    : 07.10.2006                                                      |
//|  :   .                                      |
//+----------------------------------------------------------------------------+
//| :                                                                 |
//|   sy    -                  (NULL -  )  |
//|   tf    -                                (0    -  )      |
//|   mode  -                              (MODE_LOWER|MODE_UPPER)  |
//|   start -       (2    -  )    |
//+----------------------------------------------------------------------------+
double FindNearFractal(string sy="0", int tf=0, int mode=MODE_LOWER, int start = 2) {
  if (sy=="" || sy=="0") sy=Symbol();
  double f=0;
  int d=MarketInfo(sy, MODE_DIGITS), s;
  if (d==0) if (StringFind(sy, "JPY")<0) d=4; else d=2;
 
  for (s=start; s<start+50; s++) {
    f=iFractals(sy, tf, mode, s);
    if (f!=0){b=s; return(NormalizeDouble(f, d));}
  }
  Print("FindNearFractal():   ");
  return(0);
}
//+----------------------------------------------------------------------------+
/*void FunNewBar(){
   static datetime New_Time=0;
   new_bar=false;
   if(New_Time!=Time[0]){
      New_Time=Time[0];
      new_bar=true;
   }
}*/
//+----------------------------------------------------------------------------+

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}


//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if (i>=Bars-3) return;
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (i>=Bars-2) return;
   if (first[i+1] == EMPTY_VALUE)
      if (first[i+2] == EMPTY_VALUE) 
            { first[i]  = from[i];  first[i+1]  = from[i+1]; second[i] = EMPTY_VALUE; }
      else  { second[i] =  from[i]; second[i+1] = from[i+1]; first[i]  = EMPTY_VALUE; }
   else     { first[i]  = from[i];                           second[i] = EMPTY_VALUE; }
}

   